#include <CtrlLib/CtrlLib.h>
#include <Docking/Docking.h>
#include <GLDraw/GLDraw.h>
#include <GLCtrl/GLCtrl.h>

using namespace Upp;

#define LAYOUTFILE <GLDockDemo/GLDockDemo.lay>
#include <CtrlCore/lay.h>


struct OpenGLExample : GLCtrl {
	Point point;

	virtual void GLPaint() {
		Size sz = GetSize();
	
		GLDraw w;
		
		w.Init(sz);

		w.DrawRect(0, 0, sz.cx, sz.cy, SWhite);
		w.DrawRect(10, 10, 30, 30, SRed);
		w.DrawLine(45, 45, 80, 120, 4, Blue);
		w.DrawLine(80, 90, 400, 0, PEN_DASHDOT);
		w.DrawImage(200, 10, CtrlImg::reporticon());
		const char *text = "This text is centered";
		Size tsz = GetTextSize(text, Arial(25).Bold());
		w.DrawText((sz.cx - tsz.cx) / 2, (sz.cy - tsz.cy) / 2, text, Arial(27).Bold(), SBlue);
		w.Clipoff(200, 50, 95, 100);
		w.DrawText(0, 80, "CLIPPED", Roman(25));
		w.End();

		GLDraw::ClearCache(); // This is required because GLCtrl creates a new OpenGL context,
		                      // invalidating all texture handles
	}

	virtual void MouseMove(Point p, dword) {
		point = p;
		Refresh();
	}
};


struct OpenGLExample2 : GLCtrl {
	Point point;

	virtual void GLPaint() {
		Size sz = GetSize();
	
		GLDraw w;
		
		w.Init(sz);

		w.DrawRect(0, 0, sz.cx, sz.cy, SWhite);
		w.DrawRect(10, 10, 30, 30, SRed);
		w.DrawLine(45, 45, 80, 120, 4, Blue);
		w.DrawLine(80, 90, 400, 0, PEN_DASHDOT);
		w.DrawImage(200, 10, CtrlImg::reporticon());
		const char *text = "This text is centered";
		Size tsz = GetTextSize(text, Arial(25).Bold());
		w.DrawText((sz.cx - tsz.cx) / 2, (sz.cy - tsz.cy) / 2, text, Arial(27).Bold(), SBlue);
		w.Clipoff(200, 50, 95, 100);
		w.DrawText(0, 80, "CLIPPED", Roman(25));
		w.End();

		GLDraw::ClearCache(); // This is required because GLCtrl creates a new OpenGL context,
		                      // invalidating all texture handles
	}

	virtual void MouseMove(Point p, dword) {
		point = p;
		Refresh();
	}
};




class GLDockWindow : public WithGLDockLayout<DockWindow>
{
public:   
	OpenGLExample gl;
	OpenGLExample2 gl2;
	TreeCtrl tree;
	void DockInit() override; 
	GLDockWindow();
};

GLDockWindow::GLDockWindow()
{
   CtrlLayout(*this, "GL Docking Example");
	gl.SetFrame(InsetFrame());
	gl2.SetFrame(InsetFrame());
	Add(gl.HSizePos(10, 10).VSizePos(10, 10));
	Sizeable().Zoomable();
}

void GLDockWindow::DockInit()
{
   DockLeft(Dockable(gl2, t_("GL Docking window")).SizeHint(Size(200, 200))); 
   DockRight(Dockable(tree, t_("Tree Docking window")).SizeHint(Size(200, 200))); 
}


GUI_APP_MAIN
{
	Ctrl::GlobalBackPaint();
	GLDockWindow win;
	win.Open();
	win.Run();
}
